SystemOrganization addCategory: #'Cormas-Model-FireAutomata'!

CMAgentCommLocation subclass: #CMFireman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-Model-FireAutomata'!

!CMFireman commentStamp: 'NickPapoulias 9/16/2016 09:47' prior: 0!
TODO!

!CMFireman methodsFor: 'as yet unclassified' stamp: 'BrunoBonte 4/25/2018 13:13'!
extinctFire

		self patch state = #fire ifTrue: [self patch state: #empty. self patch bufferState: #empty. ]! !

!CMFireman methodsFor: 'as yet unclassified' stamp: 'BrunoBonte 4/25/2018 13:17'!
move

	| firedNeighbours |
	firedNeighbours := self nearestLocationsVerifying: [:cell | cell state = #fire] withinRadius: 4.
	firedNeighbours isEmpty
		ifTrue: [self randomWalk]
		ifFalse: [
			"self leave."
			self moveTo: (Cormas selectRandomlyFrom: firedNeighbours)
		]! !

!CMFireman methodsFor: 'as yet unclassified' stamp: 'BrunoBonte 4/25/2018 11:44'!
pov
	"^#empty ^#tree ^#fire ^#ash"

	^ Color blue! !

!CMFireman methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/19/2016 12:09'!
step

	self move.
	self extinctFire.! !

CMSpatialEntityCell subclass: #CMFireAutomataCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-Model-FireAutomata'!

!CMFireAutomataCell commentStamp: 'SergeStinckwich 4/3/2016 14:55' prior: 0!
I'm a cell of a FireAutomata. Four states are possible: #tree, #empty, #ash, #fire!

!CMFireAutomataCell methodsFor: 'pov' stamp: 'NickPapoulias 9/15/2016 10:31'!
ash
	"^#empty ^#tree ^#fire ^#ash"

	^ Color gray! !

!CMFireAutomataCell methodsFor: 'pov' stamp: 'NickPapoulias 9/15/2016 11:39'!
empty
	"^#empty ^#tree ^#fire ^#ash"

	^ Color black! !

!CMFireAutomataCell methodsFor: 'pov' stamp: 'NickPapoulias 9/15/2016 10:31'!
fire
	"^#empty ^#tree ^#fire ^#ash"

	^ Color red ! !

!CMFireAutomataCell methodsFor: 'init' stamp: 'SergeStinckwich 4/2/2015 20:39'!
init50
	Cormas random < 0.5
		ifTrue: [ self state: #tree ]
		ifFalse: [ self state: #empty ]! !

!CMFireAutomataCell methodsFor: 'init' stamp: 'SergeStinckwich 4/2/2015 20:39'!
init53
	Cormas random < 0.53
		ifTrue: [ self state: #tree ]
		ifFalse: [ self state: #empty ]! !

!CMFireAutomataCell methodsFor: 'init' stamp: 'SergeStinckwich 4/2/2015 20:39'!
init58
	Cormas random < 0.58
		ifTrue: [ self state: #tree ]
		ifFalse: [ self state: #empty ]! !

!CMFireAutomataCell methodsFor: 'init' stamp: 'SergeStinckwich 3/5/2015 17:24'!
initEmpty
	self state: #empty! !

!CMFireAutomataCell methodsFor: 'init' stamp: 'NickPapoulias 9/15/2016 11:23'!
initWith: aNumber

	Cormas random < aNumber
		ifTrue: [ self state: #tree ]
		ifFalse: [ self state: #empty ]! !

!CMFireAutomataCell methodsFor: 'control' stamp: 'NicolasBecu 4/30/2018 09:36'!
newState
	self state = #tree
		ifTrue: [( (self neighbourhood anySatisfy: [ :a | a state = #fire ]) and:[Cormas random < 0.5])
				ifTrue: [ self bufferState: #fire ]
				ifFalse: [ self bufferState: #tree ] ].
	self state = #fire
		ifTrue: [ Cormas random < 0.05
						ifTrue: [self bufferState: #ash]
						ifFalse: [self bufferState: #fire] ].
	self state = #ash
		ifTrue: [ Cormas random < 0.2
						ifTrue: [self bufferState: #empty ]
						ifFalse: [self bufferState: #ash]].
	self state = #empty
		ifTrue: [ self bufferState: #empty ].
		! !

!CMFireAutomataCell methodsFor: 'pov' stamp: 'NicolasBecu 4/30/2018 09:16'!
pov
	"^#empty ^#tree ^#fire ^#ash"
"	(self occupantsAt: CMFireman) isEmpty not ifTrue:[^Color brown]."

	^ self perform: self state! !

!CMFireAutomataCell methodsFor: 'pov' stamp: 'NickPapoulias 9/15/2016 10:32'!
tree
	"^#empty ^#tree ^#fire ^#ash"

	^ Color green! !

CormasModel subclass: #CMFireAutomataModel
	instanceVariableNames: 'trees theCMFireAutomataCells numberOfFires percentageOfTrees theFiremans numberOfFiremen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-Model-FireAutomata'!

CMFireAutomataModel class
	instanceVariableNames: 'defaultInit'!

!CMFireAutomataModel commentStamp: 'SergeStinckwich 3/24/2016 16:01' prior: 0!
This model illustrates how the principles of cellular automata are implemented in Cormas. 

The spatial entity of the model (the cell), named FireAutomataCell, can take four states: #fire (red), #tree (green), #ash (grey), #empty (white). 

The initial state of each cell of the spatial grid is either set to #tree with a probability p or to #empty with a probability 1-p. 

One cell is set on fire, and then the spreading of the fire, defined in the cell transition function, occurs. The transition function is the following: a cell being a tree at time t-1 will become on fire at time t if at least one of its 4 neighbours (North, East, South, West) is on fire at time t-1. 

The cells being on fire will become ash at the next timestep, the cells being ash will become empty at the next timestep. 

The probability to observe a resteint fire is high if p is lower than 0.55, whereas when p is greater than 0.55, a global fire is likely to occur. 

This percolation threshold characterizes cellular automata which are representing diffusion processes.!

CMFireAutomataModel class
	instanceVariableNames: 'defaultInit'!

!CMFireAutomataModel class methodsFor: 'examples' stamp: 'EtienneDelay 5/30/2018 23:00'!
createInJSONFile
	"Create a JSON file for example 8"

	| stream |
	stream := FileStream newFileNamed: 'input.json'.
	stream nextPutAll: self inJSON.
	stream close! !

!CMFireAutomataModel class methodsFor: 'default settings' stamp: 'NicolasBecu 4/30/2018 13:35'!
defaultControl
	^ #step:! !

!CMFireAutomataModel class methodsFor: 'default settings' stamp: 'NicolasBecu 4/30/2018 12:39'!
defaultInit

	^ defaultInit ifNil: [ defaultInit := #init58WithFireWithFiremen ]! !

!CMFireAutomataModel class methodsFor: 'default settings' stamp: 'NickPapoulias 9/15/2016 10:55'!
defaultInit: aSelector

	defaultInit := aSelector! !

!CMFireAutomataModel class methodsFor: 'default settings' stamp: 'SergeStinckwich 3/29/2016 16:53'!
defaultProbes
	^ #(#nbTrees)! !

!CMFireAutomataModel class methodsFor: 'examples' stamp: 'NicolasBecu 5/2/2018 00:30'!
example1
	| aModel nbLines v es anim |
	aModel := self
		initialize;
		new.
	nbLines := 100.
	aModel initializeSpaceModel.
	aModel
		createGridX: nbLines
		Y: nbLines
		neighbourhood: 4
		closed: true.
	v := RTView new.
	
	aModel activeInit: #init58WithFire.
	aModel initSimulation.
	aModel runStep.
	es := (RTBox new
		color: [ :e | 
			e state == #tree
				ifTrue: [ Color green ]
				ifFalse: [ e state == #fire
						ifTrue: [ Color red ]
						ifFalse: [ e state == #ash
								ifTrue: [ Color gray ]
								ifFalse: [ Color black ] ] ] ];
		size: 25) elementsOn: aModel theCMFireAutomataCells.
	v addAll: es.
	RTGridLayout new
		gapSize: 0;
		lineItemsCount: aModel spaceModel column;
		on: v elements.
	v canvas camera focusOnCenterScaled.
	anim := RTActiveAnimation new.
	anim intervalInMilliseconds: 0.
	anim
		blockToExecute: [ aModel runStep.
			v elements do: #updateShape ].
	anim inView: v.
	v openWithToolbar! !

!CMFireAutomataModel class methodsFor: 'examples' stamp: 'NicolasBecu 5/13/2018 00:21'!
example2
	| aModel |
	aModel := self newWithProgrammableScenario
		numberOfFires: 3;
		numberOfFiremen: 2;
		percentageOfTrees: 0.58;
		dimensions: 80 -> 80;
		activeControl: #step:;
		initSimulation.
	(CMSimulationGrid new on: aModel with: aModel theCMFireAutomataCells) runAndVisualize! !

!CMFireAutomataModel class methodsFor: 'examples' stamp: 'NicolasBecu 5/13/2018 00:22'!
example3
	| aModel |
	aModel := self newWithProgrammableScenario
		numberOfFires: 3;
		numberOfFiremen: 20;
		percentageOfTrees: 0.60;
		dimensions: 60 -> 80;
		activeControl: #step:;
		initSimulation.
	(CMSimulationGrid new
		on: aModel
		withCells: aModel theCMFireAutomataCells
		withSituatedEntities: aModel theCMFiremans) runAndVisualize! !

!CMFireAutomataModel class methodsFor: 'examples' stamp: 'NicolasBecu 5/13/2018 00:22'!
example4
	| aModel |
	"reset probes saving specification"
	self setActiveProbes: OrderedCollection new.
	"Parameterize model"
	aModel := self newWithProgrammableScenario
		numberOfFires: 3;
		numberOfFiremen: 20;
		percentageOfTrees: 0.60;
		dimensions: 60 -> 80;
		activeControl: #step:;
		initDataStructures;
		"init simulation"
			initSimulation.
	"open interface"
	(CMSimulationGrid new
		on: aModel
		withCells: aModel theCMFireAutomataCells
		withSituatedEntities: aModel theCMFiremans) runAndVisualizeWithMenus! !

!CMFireAutomataModel class methodsFor: 'examples' stamp: 'NicolasBecu 5/13/2018 00:22'!
example5
	| aModel probes |
	"reset probes saving specification"
	self setActiveProbes: OrderedCollection new.
	"set model configuration"
	aModel := self newWithProgrammableScenario
		numberOfFires: 3;
		numberOfFiremen: 20;
		percentageOfTrees: 0.60;
		dimensions: 60 -> 80;
		activeControl: #step:.
	"set probes configuration (probes to save)"
	probes := OrderedCollection new.
	probes add: 'CMFireAutomataModel>>nbFires'.
	probes add: 'CMFireAutomataModel>>nbAshes'.
	aModel class setActiveProbes: probes.
	"Init simulation"
	aModel initSimulation.
	"create view that control the model and enables visualisation of non dynamic charts"
	(CMSimulationGrid new
		on: aModel
		withCells: aModel theCMFireAutomataCells
		withSituatedEntities: aModel theCMFiremans) runAndVisualizeWithMenus! !

!CMFireAutomataModel class methodsFor: 'examples' stamp: 'NicolasBecu 5/13/2018 11:02'!
example6
	| aModel |
	"set model configuration"
	aModel := self initialize new.
	aModel
		activeInit: #init58WithFireWithFiremen;
		" #initWithProgrammableScenario;"
			numberOfFires: 3;
		numberOfFiremen: 20;
		percentageOfTrees: 0.60;
		dimensions: 60 -> 80;
		activeControl: #step:.
	aModel simManager
		initializeSimulation;
		finalTime: 100;
		runSimulation.
	Transcript
		cr;
		show: 'Number of steps: ' , aModel simManager currentTime asString;
		cr;
		show: 'Number of fires: ' , aModel nbFires asString;
		cr;
		show: 'Number of ashes: ' , aModel nbAshes asString;
		open.
	"aModel inspect"! !

!CMFireAutomataModel class methodsFor: 'examples' stamp: 'NicolasBecu 5/13/2018 13:06'!
example7
	| aModel probes |
	"set model configuration"
	aModel := self initialize new.
	aModel
		activeInit: #init58WithFireWithFiremen;
		" #initWithProgrammableScenario;"
			numberOfFires: 3;
		numberOfFiremen: 20;
		percentageOfTrees: 0.60;
		dimensions: 60 -> 80;
		activeControl: #step:.
	"set probes configuration (probes to save)"
	probes := OrderedCollection new.
	probes add: 'CMFireAutomataModel>>nbFires'.
	probes add: 'CMFireAutomataModel>>nbAshes'.
	aModel class setActiveProbes: probes.
	aModel simManager
		initializeSimulation;
		finalTime: 100;
		runSimulation.
	(CMSimpleChart newOn: aModel)  refresh openWithToolbar ! !

!CMFireAutomataModel class methodsFor: 'examples' stamp: 'EtienneDelay 5/30/2018 23:04'!
example8
	"Example used in OpenMole (https://openmole.org/)"
    | conf aModel |
	 "self createInJSONFile." "OpenMole usually generate this file"
    conf := CMOpenMoleExchange loadJSONFile: 'input.json'.
    aModel := self newWithProgrammableScenario
        numberOfFires: (conf at: #numberOfFires) ;
        numberOfFiremen: (conf at: #numberOfFiremen);
        percentageOfTrees: (conf at: #percentageOfTrees);
        dimensions: (conf at: #dimensionMin) -> (conf at: #dimensionMax);
        activeControl: #step:;
        initSimulation.
    aModel simManager
        initializeSimulation;
        finalTime: 100;
        runSimulation.
    CMOpenMoleExchange saveJSONFile: aModel data! !

!CMFireAutomataModel class methodsFor: 'description' stamp: 'NicolasBecu 4/30/2018 11:49'!
howToRunIt
<script>
| txt |
txt := '1. Prepare the visualisation of the spatial grid\' withCRs asText allBold.

txt := txt, '1.1 Click on the first icon of the ' asText, ('Visualisation ' asText makeAllColor: Color red), 'area to open the standard spatial grid.\' withCRs asText.

txt := txt, '1.2 In the ' asText, ('Topology ' asText allItalic), 'menu, clicking on the ' asText, ('Grid size ' asText allItalic), 'item opens a window allowing you to choose the number of lines and columns. For example, choose 30 * 30.\' withCRs asText.

txt := txt, '1.3 Check the border condition: ' asText, ('Topology -> Grid boundaries -> closed' asText allItalic), '.\' withCRs asText.

txt := txt, '1.4 Right-click within the spatial grid window to select the ' asText, ('pov ' asText allItalic), 'view for ' asText, ('FireAutomata_Cell ' asText allItalic), '.\' withCRs asText.

txt := txt, '1.5 To display the legend of this viewpoint: ' asText, ('Tools -> Display legends.\\' withCRs asText allItalic).



txt := txt, ('2. Prepare the initial spatial grid\' withCRs asText allBold).

txt := txt, '2.1 Click on the ' asText, ('Initialize ' asText allItalic), 'button of the ' asText, ('Simulation ' asText makeAllColor: Color red),  'area.\' withCRs asText.

txt := txt, '2.2 Select the ' asText, ('init53 ' asText allItalic), 'and ' asText, ('stepSynchronously: ' asText allItalic), 'methods, then validate by clicking on ' asText, ('Apply and close.\' withCRs asText allItalic).

txt := txt, '2.3 From the spatial grid menu, use ' asText, ('Tools -> Click to... -> Change attribute... -> state' asText allItalic), ', enter ' asText, ('fire ' asText allItalic), 'and validate. The cursor takes a new shape. Click on a cell to change manually its state to fire, then switch back to the mouse select mode with ' asText, ('Tools -> Click to... -> Select ' asText allItalic), '.\\' withCRs asText. 


txt := txt, ('3. Run the model\' withCRs asText allBold).

txt := txt, '3.1 Enter 50 in the ' asText, ('Final time ' asText allItalic), 'input field of the ' asText,  ('Simulation ' asText makeAllColor: Color red),  'area.\' withCRs asText.

txt := txt, '3.2 Click on the ' asText, ('Run ' asText allItalic), 'button of the ' asText,  ('Simulation ' asText makeAllColor:Color red),  'area.\\' withCRs asText.



txt := txt, ('4. Have a look at the charts\' withCRs asText allBold).

txt := txt, '4.1 Click on the third icon of the ' asText, ('Visualisation ' asText makeAllColor: Color red), 'area to open the charts window.\\' withCRs asText.



txt := txt, ('5. Run alternative versions of the model\' withCRs asText allBold).

txt := txt, '5.1 Select the ' asText, ('init58 ' asText allItalic), 'and ' asText, ('stepSynchronously: ' asText allItalic), 'methods, then run the model again.\' withCRs asText.

txt := txt, '5.2 Select the ' asText, ('init53 ' asText allItalic), 'and ' asText, ('stepAsynchronously: ' asText allItalic), 'methods, then run the model again.\' withCRs asText.

txt inspect
"ComposedTextView open: txt asValue label: ('How to run ', self name, '     step-by-step instructions') icon: (Icon constantNamed: #workspace) extent: 620@550" ! !

!CMFireAutomataModel class methodsFor: 'examples' stamp: 'SergeStinckwich 5/30/2018 09:38'!
inJSON
	"Use in example8"

	^ '{
    "numberOfFires": 3,
	"numberOfFiremen": 20,
	"percentageOfTrees": 0.65,
	"dimensionMin": 60, 
	"dimensionMax": 80
}
'! !

!CMFireAutomataModel class methodsFor: 'examples' stamp: 'NickPapoulias 9/15/2016 11:35'!
newWithProgrammableScenario

	^ self 
		defaultInit: #initWithProgrammableScenario;
		initialize;
		new.! !

!CMFireAutomataModel methodsFor: 'programmable scenario' stamp: 'NickPapoulias 9/15/2016 11:38'!
dimensions: aPair

	self initializeSpaceModel.

	self
		createGridX: aPair key
		Y: aPair value
		neighbourhood: 4
		closed: true.! !

!CMFireAutomataModel methodsFor: 'description' stamp: 'NicolasBecu 4/30/2018 12:18'!
howToRunIt

^self class howToRunIt ! !

!CMFireAutomataModel methodsFor: 'init' stamp: 'nbecu 6/2/2015 13:19'!
init53
	self initCells: #init53! !

!CMFireAutomataModel methodsFor: 'init' stamp: 'NicolasBecu 5/1/2018 00:51'!
init53WithFire
	self createGridX: 80 Y: 80 neighbourhood: 4 closed: false.
	self initCells: #init53.
	self pickCell state: #fire.! !

!CMFireAutomataModel methodsFor: 'init' stamp: 'NicolasBecu 5/1/2018 00:51'!
init58
	self createGridX: 80 Y: 80 neighbourhood: 4 closed: false.
	self initCells: #init58.! !

!CMFireAutomataModel methodsFor: 'init' stamp: 'NicolasBecu 5/2/2018 00:49'!
init58WithFire
	self initCells: #init58.
	self pickCell ifNotNil:[:c| c state: #fire]! !

!CMFireAutomataModel methodsFor: 'init' stamp: 'NicolasBecu 4/30/2018 13:04'!
init58WithFireWithFiremen
	| aCell |
	self createGridX: 80 Y: 80 neighbourhood: 4 closed: false.
	self initCells: #init58.
	1 to: self numberOfFires do: [:i | 
			aCell :=  self pickCell.
			aCell = nil ifTrue:[self halt].
			aCell state: #fire].
	self initAgents.! !

!CMFireAutomataModel methodsFor: 'init' stamp: 'NicolasBecu 4/30/2018 12:33'!
init58WithMultipleFires

	self initCells: #init58.
	1 to: self numberOfFires  do: [:i | self pickCell state: #fire].
	! !

!CMFireAutomataModel methodsFor: 'instance-creation' stamp: 'NicolasBecu 4/30/2018 12:33'!
initAgents
"To be completed"

	self setRandomlyLocatedAgents: CMFireman n: self numberOfFiremen.
	self generateSymetricNetworkDensity: 1 forAgents: CMFireman.! !

!CMFireAutomataModel methodsFor: 'init' stamp: 'NicolasBecu 4/30/2018 13:07'!
initWithFiremen
	| aCell |
	self createGridX: 80 Y: 80 neighbourhood: 4 closed: false.
	self initCells: #initWith: withArguments: {60}.
	1 to: self numberOfFires do: [:i | 
			aCell :=  self pickCell.
			aCell = nil ifTrue:[self halt].
			aCell state: #fire].
	self initAgents.! !

!CMFireAutomataModel methodsFor: 'programmable scenario' stamp: 'NicolasBecu 4/30/2018 12:33'!
initWithProgrammableScenario

	self initCells: #initWith: withArguments: {percentageOfTrees}.
	1 to: self numberOfFires do: [:i | self pickCell state: #fire].
	self initAgents.! !

!CMFireAutomataModel methodsFor: 'probes' stamp: 'BrunoBonte 5/2/2018 19:39'!
nbAshes
	^ self theCMFireAutomataCells count: [ :c | c state = #ash]! !

!CMFireAutomataModel methodsFor: 'probes' stamp: 'BrunoBonte 5/2/2018 19:39'!
nbFires
	^ self theCMFireAutomataCells count: [ :c | c state = #fire ]! !

!CMFireAutomataModel methodsFor: 'probes' stamp: 'NicolasBecu 4/30/2018 09:32'!
nbTrees
	^ self theCMFireAutomataCells  count: [ :c | c state = #tree ]! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'NicolasBecu 4/30/2018 13:07'!
numberOfFiremen

	^numberOfFiremen ifNil:[numberOfFiremen := 20]! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'NickPapoulias 9/19/2016 12:22'!
numberOfFiremen: aNumber

	numberOfFiremen := aNumber! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'NicolasBecu 4/30/2018 13:07'!
numberOfFires

	^ numberOfFires ifNil:[numberOfFires := 3]! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'NickPapoulias 9/15/2016 11:25'!
numberOfFires: aNumber

	numberOfFires := aNumber! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'NickPapoulias 9/15/2016 11:28'!
percentageOfTrees

	^ percentageOfTrees ! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'NickPapoulias 9/15/2016 11:28'!
percentageOfTrees: aNumber

	percentageOfTrees := aNumber! !

!CMFireAutomataModel methodsFor: 'control' stamp: 'NickPapoulias 9/19/2016 12:10'!
step: t
"To be completed"

	self stepSynchronously: t.
	self theCMFiremans do: [:fm | fm step].! !

!CMFireAutomataModel methodsFor: 'control' stamp: 'nbecu 6/2/2015 13:21'!
stepAsynchronously: t
	super stepAsynchronously: t.! !

!CMFireAutomataModel methodsFor: 'control' stamp: 'nbecu 6/2/2015 13:21'!
stepSynchronously: t
	super stepSynchronously: t.! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 14:57'!
theCMFireAutomataCells
	"Returns a collection of all the instances of the sub classes collected by cormasModel.
	!!!! This method was automatically generated by Cormas !!!!"

	^ theCMFireAutomataCells ifNil: [ theCMFireAutomataCells := OrderedCollection new ]! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 14:57'!
theCMFireAutomataCells: aCollection
	theCMFireAutomataCells := aCollection! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'NickPapoulias 9/19/2016 10:28'!
theCMFiremans
	"Returns a collection of all the instances of the sub classes collected by cormasModel.
	This method was automatically generated by Cormas.
	!!!! BECAREFUL, You should not modify this method as it can be generated again when changing the value (Sensitivity Analysis for ex) !!!!"


^theFiremans ifNil:[theFiremans := IndexedSet new]! !

!CMFireAutomataModel methodsFor: 'accessing' stamp: 'NickPapoulias 9/19/2016 10:28'!
theCMFiremans: aNewCollection
	"Set a new collection for theXXXs attribute.
	This method was automatically generated by Cormas.
	!!!! BECAREFUL, You should not modify this method as it can be generated again when changing the value (Sensitivity Analysis for ex) !!!!"

	theFiremans := aNewCollection! !

!CMFireAutomataModel methodsFor: 'deprecated' stamp: 'SergeStinckwich 4/24/2015 13:16'!
trees
	trees isNil
		ifTrue: [ trees := OrderedCollection new ].
	^ trees! !

!CMFireAutomataModel methodsFor: 'deprecated' stamp: 'SergeStinckwich 3/24/2016 16:02'!
trees: aCollection
	trees := aCollection! !

!CMFireAutomataModel methodsFor: 'deprecated' stamp: 'SergeStinckwich 4/3/2016 14:56'!
treesData
	"return the data to be plotted with the trees chart"

	^ (self theCMFireAutomataCells count: [ :c | c state = #tree ]) / self theCMFireAutomataCells size! !
